var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name2 in all)
    __defProp(target, name2, { get: all[name2], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  Config: () => Config,
  apply: () => apply,
  name: () => name,
  usage: () => usage
});
module.exports = __toCommonJS(src_exports);
var import_koishi = require("koishi");
var name = "github-og";
var usage = `
## 响应的消息格式
* koishijs/koishi
* https://github.com/koishijs/koishi
`;
var Config = import_koishi.Schema.object({});
async function digest(message) {
  const msgUint8 = new TextEncoder().encode(message);
  const hashBuffer = await crypto.subtle.digest("SHA-256", msgUint8);
  return import_koishi.Binary.toHex(hashBuffer);
}
__name(digest, "digest");
function isValidHttpUrl(str) {
  const pattern = new RegExp(
    "^(?:(?:(?:https?):)?\\/\\/)(?:(?:(?:[a-z0-9\\u00a1-\\uffff][a-z0-9\\u00a1-\\uffff_-]{0,62})?[a-z0-9\\u00a1-\\uffff]\\.)+(?:[a-z\\u00a1-\\uffff]{2,}\\.?))(?:[/?#]\\S*)?$",
    "i"
  );
  return pattern.test(str);
}
__name(isValidHttpUrl, "isValidHttpUrl");
function apply(ctx) {
  ctx.on("message-created", async (session) => {
    const input = import_koishi.h.select(session.elements, "text").join("").trim();
    if (input.startsWith(`https://github.com/`) && isValidHttpUrl(input)) {
      const parts = input.split("/");
      const owner = parts[3];
      const repository = parts[4];
      if (owner && repository) {
        const originalUrl = `https://github.com/${owner}/${repository}`;
        const hashHex = await digest(originalUrl);
        await session.send(import_koishi.h.img(`https://opengraph.githubassets.com/${hashHex}/${owner}/${repository}`));
      }
      return;
    }
    if (/^[A-Za-z0-9_-]+\/[A-Za-z0-9_.-]+$/.test(input)) {
      const parts = input.split("/");
      if (Number.isInteger(+parts[0])) return;
      const originalUrl = `https://github.com/${input}`;
      const hashHex = await digest(originalUrl);
      return await session.send(import_koishi.h.img(`https://opengraph.githubassets.com/${hashHex}/${input}`));
    }
  });
}
__name(apply, "apply");
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  Config,
  apply,
  name,
  usage
});
